
/* ///////////  Logique relais F6ZJD  ///////////////
 *      Il s'agit ici des  commandes de base
 *      Les codes DTMF ne sont pas officiels *      
 *      
 *  PIN 2     Info réception 1750 Hz
 *  PIN 8     Info Squelch
 *  PIN 9     Info relais sous batteries
 *  PIN 13    M/A TX4
 *  (Utilisés en interne PIN 3,4,5,6,7,10,11)
 *  
 *  http://f5mna.free.fr
 *  Janvier 2017
 *//////////////////////////////////////////////


//////////////    Vocale   /////////////////////
#include <SoftwareSerial.h>
#include <DFPlayer_Mini_Mp3.h>
SoftwareSerial mySerial(10, 11); // RX, TX

int ConfDTMF = 3;  // Confirmation de réception d'un code DTMF Pin 3
int DTMF1 = 4;     // Sortie 1 MT8870 Pin 4
int DTMF2 = 5;     // Sortie 2 MT8870     5
int DTMF3 = 6;     // Sortie 3 MT8870     6
int DTMF4 = 7;     // Sortie 4 MT8870     7

int NiveauS = A0;
int Appel = 2;
int Squelch = 8;
//int Batterie = 9;
int TX = 13;

int valAppel, valSquelch,valDTMF ; 
int valTX = 1;
int tempo = 0;// Base tempo
long temp  = 1000 ;  // Base tempo
int Acceuil = 1;
int fin = 1; // Mise en route tempo
int NiveS;
int S; //Niveau Smetre

///Batterie
int  UBatt , VoltBatt, VoltBattV, UVolt, UDizVolt ;

boolean QSO = false;
boolean OKApp = false; //OK après 1750
boolean Norm = true;   // Autorisation marche normale
boolean Vocal = true;  // Autorisation message

////DTMF
int buttonState;         // Prise en compte du changement d'état de la confirmation DTMF
int Buffer[25];          // Tableau mémorisation des codes entrant.
int DTMF = 0;            // Somme des sorties DTMF
boolean OK = false;      // Gestion des codes
int Cod = 0;             // Nbre de symboles DTMF pris en compte
int Cd;                  // Nombre de codes à envoyer

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void setup() {
  Serial.begin (9600);
  //pinMode (Appel, INPUT);
  pinMode (TX, OUTPUT);
  pinMode (Squelch, INPUT);
  //pinMode (Batterie, INPUT);

  pinMode (ConfDTMF, INPUT); // Validation code DTMF
  pinMode (DTMF1, INPUT); // Sortie MT8870
  pinMode (DTMF2, INPUT); // Sortie MT8870
  pinMode (DTMF3, INPUT); // Sortie MT8870
  pinMode (DTMF4, INPUT); // Sortie MT8870

  ///// Vocal //////
  mySerial.begin(9600);
  delay(400);
  mp3_set_serial (mySerial); //set softwareSerial for DFPlayer-mini mp3 module
  delay(400);
  mp3_set_volume (25); //  Volume de 0 à 30
  delay(400);
}

///////////    Marche Normale  //////////////////////////////////////////////////////////////////////////////////////////
void Normale() {

  valAppel = digitalRead (Appel);
  if (valAppel == HIGH)OKApp = true;          // Si on reçoit du 1750 Hz Pin 2

  if ((valAppel == LOW) and (OKApp == true)) { // Lorsqu'on relache
    digitalWrite (TX, HIGH);
    OKApp = false;
    delay (500);
    fin = 0;                        // Mise en route tempo
   if (Vocal == true)
   {mp3_play (1100);                // Message d'acceuil
    delay (5000);}
    Acceuil = 0;
   if (Vocal == true)
    {mp3_play (1103);                // Message d'acceuil
    delay (1000);}
  }
}

///////////////       Tension batterie     ////////////////
void Ubatterie () {
  int TensionBatt = A5; // analog pin A5
  float UBatt = 0;

  UBatt = (analogRead( TensionBatt) * 15) / 1024.0;  // 15 Volts maxi en entrée.
  VoltBatt = UBatt * 10;
  VoltBattV = (VoltBatt / 10) * 10;
  UDizVolt =  VoltBatt - VoltBattV;
  UVolt = (VoltBatt / 10);
  Serial.println ("Tension panneaux solaires");
  Serial.println (UBatt);
  Serial.println (UVolt);
  Serial.println (UDizVolt);
  Serial.println ();
  mp3_play (1401);                // Tension batterie
  delay (1500);
  switch (UVolt) {
    case 0:
      mp3_play (1500); //zero
      delay (1000);
      break;

    case 1:
      mp3_play (1501); //1
      delay (1000);
      break;

    case 2:
      mp3_play (1502); //2
      delay (1000);
      break;

    case 3:
      mp3_play (1503); //3
      delay (1000);
      break;

    case 4:
      mp3_play (1504); //4
      delay (1000);
      break;

    case 5:
      mp3_play (1505); //5
      delay (1000);
      break;

    case 6:
      mp3_play (1506); //6
      delay (1000);
      break;

    case 7:
      mp3_play (1507); //7
      delay (1000);
      break;

    case 8:
      mp3_play (1508); //8
      delay (1000);
      break;

    case 9:
      mp3_play (1509); //9
      delay (1000);
      break;

    case 10:
      mp3_play (1510); //10
      delay (1000);
      break;

    case 11:
      mp3_play (1511); //11
      delay (1000);
      break;

    case 12:
      mp3_play (1512); //12
      delay (1000);
      break;

    case 13:
      mp3_play (1513); //13
      delay (1000);
      break;

    case 14:
      mp3_play (1514); //14
      delay (1100);
      break;

    case 15:
      mp3_play (1515); //15
      delay (1000);
      break;
  }

  switch ( UDizVolt) {
    case 1:
      mp3_play (1601); //1
      delay (1000);
      break;

    case 2:
      mp3_play (1602); //2
      delay (1000);
      break;

    case 3:
      mp3_play (1603); //3
      delay (1000);
      break;

    case 4:
      mp3_play (1604); //4
      delay (1000);
      break;

    case 5:
      mp3_play (1605); //5
      delay (1000);
      break;

    case 6:
      mp3_play (1606); //6
      delay (1000);
      break;

    case 7:
      mp3_play (1607); //7
      delay (1000);
      break;

    case 8:
      mp3_play (1608); //8
      delay (1000);
      break;

    case 9:
      mp3_play (1609); //9
      delay (1000);
      break;
  }
}




void Maintenance()  
//////////////////////////////////
/*          DTMF
 * Blocage relais code 0123 
 * Deblocage relais code 0456
 * Tension batterie Code 0789
 */////////////////////////////////
{ 
   /////////////// Blocage du relais//////////
   
    if ((Buffer[1] == 10) and (Buffer[2] == 1) and (Buffer[3] == 2) and (Buffer[4] == 3)) // Code 0123
    {
      digitalWrite (TX, LOW);             // Arrêt et blocage du  relais
      Norm = false;                       // Norm utilisation normale
      Serial.println ("Blocage");      
    }
    
    /////////////// Déblocage du relais//////////
    if ((Buffer[1] == 10) and (Buffer[2] == 4) and (Buffer[3] == 5) and (Buffer[4] == 6)) // Code 0456
    {       
      Norm = true;                        // Norm utilisation normale deblocage du relais. 
      digitalWrite (TX, LOW);             // Arrêt relais si en route pour 15 mn
      tempo = 0;                          // RAZ tempo
      temp = 1000;                        // Base tempo
      Acceuil = 1;
      fin = 1;
      QSO = false;   
      Serial.println ("Autorisation");      
    } 
    
    //////////////   Température PA et tension batterie  //////////
    if ((Buffer[1] == 10) and (Buffer[2] == 7) and (Buffer[3] == 8) and (Buffer[4] == 9)) //  Code 0789
   {                   
    Serial.println ("Annonce tension & température");
    Ubatterie (); //Tension batterie
    tempo = 0;                   // Stop répétition info
    }
}
//////////////////////////////////////////////////////////
void Smetre()
{
  NiveS = analogRead (NiveauS); //A0
  if (NiveS >= 102) S = 1209;
  if (NiveS >= 206) S = 1202;
  if (NiveS >= 307) S = 1203;
  if (NiveS >= 409) S = 1204;
  if (NiveS >= 511) S = 1205;
  if (NiveS >= 627) S = 1206;
  if (NiveS >= 716) S = 1207;
  if (NiveS >= 818) S = 1208;
  if (NiveS >= 920) S = 1209;
}
/////////////////////////////////////////////////////////
void CodDTMF()
{
    //Commandes DTMF
  valDTMF = digitalRead(ConfDTMF);                            //Confirmation DTMF
  if (valDTMF  != buttonState) {                               // Modification de cette valeur
    if (valDTMF  == LOW) {                                     // Si la valeur à changé.

      if (digitalRead(DTMF4) == HIGH) DTMF = DTMF + 1;
      if (digitalRead(DTMF3) == HIGH) DTMF = DTMF + 2;
      if (digitalRead(DTMF2) == HIGH) DTMF = DTMF + 4;
      if (digitalRead(DTMF1) == HIGH) DTMF = DTMF + 8;

      Serial.println (DTMF);
      
      if (DTMF == 10) (OK = true);                       // DTMF == 0: Ici tous les codes doivent commencer par 0 (ex 01A#)

      if (OK == true) {
        Cod++;                                           // Incrementation du compteur curseur (seconde ligne)

        Buffer[Cod] = DTMF;
        Cd = 4;                                          //Nombre de codes à envoyer     

        if (Cod == Cd) {
     /*     for (int x = 1;  x < (Cd + 1); x++)
         {
         Serial.println (Buffer[x]);
         }
     */    
          Cd = 0;
          Cod = 0;
          OK = false;
          Maintenance();
        }
      }
    }
    buttonState = valDTMF ;                                     // Confirmation de la validation DTMF (CM8870)
    DTMF = 0;
  }
}


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void loop() {

  Smetre();
  CodDTMF();
  valSquelch = digitalRead (Squelch); //Pin 8  Squelch
  valTX = digitalRead (TX);           // Pin 13  TX
  

  /////////////////////  "Acceuil normal" //////////////////////
  if ((valSquelch == LOW) and (Acceuil == 1) and (Norm == true))  Normale();  

  //////////////////////  QSO   ///////////////////////////////////
  if (valSquelch == HIGH) {
    QSO = true;
    Smetre();
  }
  if ((valSquelch == LOW) and (QSO == true) and (Acceuil == 0))
  {
   if (Vocal == true){ mp3_play (S);        // Niveau S
    delay (1200);}
   if (Vocal == true){ mp3_play (1103);     // Message K
    delay (1000);}
    tempo = 0;
    QSO  = false;
    Serial.println  (NiveS);
    
  }
  ///////////////////       Au revoir            ///////////////////
  if ((valSquelch == LOW) and (valTX == 1) and (fin == 0)) { // Si le squelch PIN 8  est à 0 est le TX en fonctionnement PIN13 .....on lance la tempo
    tempo ++;
    Serial.print ("tempo  ");
    Serial.println (tempo);

    if (tempo == temp) // 1000 = 12 sec environ
    {
      tempo = 0;
      Acceuil = 1;
      fin = 1;
      QSO = false;
      if (Vocal == true) mp3_play (1101);                // Message Au revoir
      delay (6000);
      digitalWrite (TX, LOW);
    }
  }
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
} 
